local _, Addon = ...

local TradeLog = Addon.TradeLog
local Output = Addon.Output
local L = Addon.L

--初始化Export窗口
function Output:Initialize()
    local f = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
    f:SetWidth(360)
    f:SetHeight(510)
    f:SetBackdrop({
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
        edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
        tile = true,
        tileSize = 32,
        edgeSize = 32,
        insets = {left = 8, right = 8, top = 10, bottom = 10}
    })
    f:SetBackdropColor(0, 0, 0)
    f:SetPoint("RIGHT", -20, 0)
    f:SetToplevel(true)
    f:EnableMouse(true)
    f:SetMovable(true)
    f:RegisterForDrag("LeftButton")
    f:SetScript("OnDragStart", f.StartMoving)
    f:SetScript("OnDragStop", f.StopMovingOrSizing)
    f:Hide()
	self.background = f
    do -- 创建框体标题栏纹理
        local t = f:CreateTexture(nil, "ARTWORK")
        t:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")
        t:SetWidth(360)
        t:SetHeight(64)
        t:SetPoint("TOP", f, 0, 12)
        f.texture = t
    end
    do -- 创建框体标题
        local t = f:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
        t:SetText("")
        t:SetPoint("TOP", f.texture, 0, -14)
        self.title = t
    end
    do -- 创建关闭按钮
        local cls = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
        cls:SetWidth(90)
        cls:SetHeight(23)
        cls:SetPoint("BOTTOMLEFT", 220, 10)
        cls:SetText(CLOSE)
        cls:SetScript("OnClick", function() f:Hide() end)
        local del = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
        del:SetWidth(90)
        del:SetHeight(23)
        del:SetPoint("BOTTOMLEFT", 220, 35)
        del:SetText(L["Delete All"])
        del:SetScript("OnClick",
        function(self)
			for i = #TradeLog, 1, -1 do
				table.remove(TradeLog, i)
			end
			print(L["<|cFFBA55D3TL|r>All Trade Logs was deleted!"])
            f:Hide()
		end)
        local tl = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
        tl:SetWidth(50)
        tl:SetHeight(23)
        tl:SetPoint("BOTTOMLEFT", 20, 10)
        tl:SetText(L["Trades"])
        tl:SetScript("OnClick",
        function(self) Addon:PrintTradeLog("TRADE") end)
        local ml = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
        ml:SetWidth(50)
        ml:SetHeight(23)
        ml:SetPoint("BOTTOMLEFT", 70, 10)
        ml:SetText(L["Mails"])
        ml:SetScript("OnClick",
        function(self) Addon:PrintTradeLog("MAIL") end)
        local sm = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
        sm:SetWidth(50)
        sm:SetHeight(23)
        sm:SetPoint("BOTTOMLEFT", 120, 10)
        sm:SetText(L["Sent"])
        sm:SetScript("OnClick",
        function(self) Addon:PrintTradeLog("SMAIL") end)
        local rm = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
        rm:SetWidth(50)
        rm:SetHeight(23)
        rm:SetPoint("BOTTOMLEFT", 170, 10)
        rm:SetText(L["Recevied"])
        rm:SetScript("OnClick",
        function(self) Addon:PrintTradeLog("RMAIL") end)
	end
    do -- 带Scroll的可编辑输出窗口
        local t = CreateFrame("ScrollFrame", nil, f, "UIPanelScrollFrameTemplate")
        t:SetPoint("TOPLEFT", f, 25, -40)
        t:SetWidth(290)
        t:SetHeight(420)

        local edit = CreateFrame("EditBox", nil, t)
        edit.cursorOffset = 0
        edit:SetWidth(290)
        edit:SetHeight(420)
        edit:SetPoint("TOPLEFT", t, 15, 0)
        edit:SetAutoFocus(false)
        edit:EnableMouse(true)
        edit:SetMaxLetters(99999999)
        edit:SetMultiLine(true)
        edit:SetFontObject(GameTooltipText)
        edit:SetScript("OnTextChanged", function(self)
            ScrollingEdit_OnTextChanged(self, t)
        end)
        edit:SetScript("OnCursorChanged", ScrollingEdit_OnCursorChanged)
        edit:SetScript("OnEscapePressed", edit.ClearFocus)

        self.export = edit

        t:SetScrollChild(edit)

        t:Hide()
    end
end
