local _, Addon = ...

local L = Addon.L
local MinimapIcon = Addon.MinimapIcon
local Config = Addon.Config
local Output = Addon.Output


function MinimapIcon:Initialize()
	local b = CreateFrame("Button", nil, Minimap)
	self.Minimap = b

	b:SetFrameStrata("HIGH")
	b:SetToplevel(true)
	if b.SetFixedFrameStrata then -- Classic support
		b:SetFixedFrameStrata(true)
	end
	b:SetFrameLevel(8)
	if b.SetFixedFrameLevel then -- Classic support
		b:SetFixedFrameLevel(true)
	end
	b:SetSize(31, 31)
	b:RegisterForClicks("anyUp")
	b:RegisterForDrag("LeftButton")
	b:SetHighlightTexture(136477) --"Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight"
	b.overlay = b:CreateTexture(nil, "OVERLAY")
	b.overlay:SetSize(53, 53)
	b.overlay:SetTexture(136430) --"Interface\\Minimap\\MiniMap-TrackingBorder"
	b.overlay:SetPoint("TOPLEFT")
	b.background = b:CreateTexture(nil, "BACKGROUND")
	b.background:SetSize(20, 20)
	b.background:SetTexture(136467) --"Interface\\Minimap\\UI-Minimap-Background"
	b.background:SetPoint("TOPLEFT", 7, -5)
	local icon = b:CreateTexture(nil, "ARTWORK")
	icon:SetSize(17, 17)
	icon:SetTexture("Interface\\MINIMAP\\TRACKING\\Mailbox")
	icon:SetPoint("TOPLEFT", 7, -6)
	b.icon = icon


	b:EnableMouse(true)
	b:SetMovable(true)

	b:RegisterForDrag("LeftButton")
	b:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	b:SetScript("OnDragStart", b.StartMoving)
	b:SetScript("OnDragStop", b.StopMovingOrSizing)
	b:SetScript("OnMouseDown", function(self) b.background:SetTexCoord(0.075, 0.925, 0.075, 0.925) end)
	b:SetScript("OnMouseUp", function(self) b.background:SetTexCoord(0, 1, 0, 1) end)
	-- b:SetScript("OnEnter", function(self) GameTooltip:AddLine(L["Left Click to Open Output Frame, Right Click to Open Config Frame."]) end)
	-- b:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	b:SetScript("OnClick", function(self, button)
		if button == "LeftButton" then
			if Output.background:IsShown() and Output.export:GetParent():IsShown() then
				Output.export:GetParent():Hide()
				Output.background:Hide()
			else
				Addon:PrintTradeLog("ALL")
			end
		elseif button == "RightButton" then
			InterfaceOptionsFrame_OpenToCategory("MailLogger")
			InterfaceOptionsFrame_OpenToCategory("MailLogger")
		end
	end)
	self.background = b
end